<?php
/***************************************************************************
DB class

DB class is developed to be wrapping the database functionality to enable easy usage.
One of the main goal have been to ensure its extensibility as changing database
or additional dabases.

@author Peter Wibeck
@version 2004-05-17

***************************************************************************/

DEFINE ("SQL_HOST","localhost");
DEFINE ("SQL_BDD","database");
DEFINE ("SQL_USER","username");
DEFINE ("SQL_PASSWORD","password");
DEFINE ("ERROR_MAIL","email adress to send error reports to");
DEFINE ("SHOW_ERROR_OUTPUT","false"); //true or false

class DB
{
	private $Host 		= SQL_HOST;    // Hostname of our MySQL server
	private $Database 	= SQL_BDD;     // Logical database name on that server
	private $User 		= SQL_USER;    // Database user
	private $Password 	= SQL_PASSWORD;// Database user's password

	private $Link_ID    = 0;           // Result of mysql_connect()
	private $Query_ID	= 0;           // Result of most recent mysql_query()
	private $Record		= array();     // Current mysql_fetch_array()-result
	private $Row;                      // Current row number
	private $Errno 		= 0;           // Error state of query
	private $Error 		= "";
	
	# Create a link id to the database
	# Allow to call $var = new DB($otherhost,$otherDB,$otheruser,$otherpass);
	# where $other* are connections vars different from 
	# $this->Host, etc
	function DB($altHost = "",$altDB = "",$altUser = "",$altPassword = "")
	{
		if ($altHost == "")
			$altHost = $this->Host;
		if ($altDB == "")
			$altDB = $this->Database;
		if ($altUser == "")
			$altUser = $this->User;
		if ($altPassword == "")
			$altPassword = $this->Password;

		$this->Host = $altHost;
		$this->Database = $altDB;
		$this->User = $altUser;
		$this->Password = $altPassword;
	}

	//Return the info about the variable
	function var_dump_ret($mixed = null)
	{
		ob_start();
 	 	var_dump($mixed);
  		$content = ob_get_contents();
  		ob_end_clean();
  		return $content;
	}

    # Stop the execution of the script
    # in case of error
    # $msg : the message that'll be printed    
    function halt($msg)
    {    	
    	$MailMessage = "Message: ".$msg."\n";
    	$MailMessage .= "Errno: ".$this->Errno."\n";
    	$MailMessage .= "Error: ".$this->Error."\n";
    	$MailMessage .= "HTTP_REFERER: ".$_SERVER['HTTP_REFERER']."\n";
    	$MailMessage .= "REQUEST_URI: ".$_SERVER['REQUEST_URI']."\n";
    	$MailMessage .= "GET: ".$this->var_dump_ret($_GET)."\n";
    	$MailMessage .= "POST: ".$this->var_dump_ret($_POST)."\n";
    	$MailMessage .= "USER: ".$_SESSION['UserID']." ".$_SESSION['UserFName']." ".$_SESSION['UserLName']."\n";
    	
		mail(ERROR_MAIL, "Database error at ".SQL_BDD, $MailMessage);
	
		echo ("<b>Something went wrong when trying connecting to database</b><br \>\n");
        if(SHOW_ERROR_OUTPUT == "true")
        {
	        echo("<b>Database error:</b> $msg<br \>\n");
	        echo("<b>MySQL errno</b>: $this->Errno<br \>\n");
	        echo("<b>MySQL error</b>: $this->Error<br \><br \>\n");
        }
        die("Session halted.");
    }

	# Connect to the MySQL server
	function connect()
	{
		global $DBType;
		
		if($this->Link_ID == 0)
		{
			$this->Link_ID = mysql_connect($this->Host, $this->User, $this->Password);
			if (!$this->Link_ID)
			{
				$this->halt("Link_ID == false, connect failed");
            }
            
            $SelectResult = mysql_select_db($this->Database, $this->Link_ID);
			if(!$SelectResult)
			{
				$this->Errno = mysql_errno($this->Link_ID);
				$this->Error = mysql_error($this->Link_ID);
				$this->halt("Cannot select database <i>".$this->Database."</i>");
			}
		}
	}
	
    # Send a query to the MySQL server
    # $Query_String = the query
    function query($Query_String)
    {		
		$this->Query_ID = mysql_query($Query_String,$this->Link_ID);
        $this->Row = 0;
        $this->Errno = mysql_errno();
        $this->Error = mysql_error();
        if (!$this->Query_ID)
        {
        	$this->halt("Invalid SQL: ".$Query_String);
        }
        	
		return $this->Query_ID;
	}

	# return the next record of a MySQL query
	# in an array	
    function next_record()
    {
		$this->Record = mysql_fetch_array($this->Query_ID);
		$this->Errno = mysql_errno();
		$this->Error = mysql_error();
		$stat = is_array($this->Record);
		if (!$stat)
		{
			mysql_free_result($this->Query_ID);
			$this->Query_ID = 0;
		}
		else 
		{
			$this->Row += 1;
		}
			
		return $this->Record;
    }

	# Return the number of rows affected by a query
	# (except insert and delete query)	
	function num_rows()
	{
		return mysql_num_rows($this->Query_ID);
	}

	# Return the number of affected rows
	# by a UPDATE, INSERT or DELETE query
    function affected_rows()
    {
		return mysql_affected_rows($this->Link_ID);
	}
    
    # Return the id of the last inserted element    
	function insert_id()
	{
		return mysql_insert_id($this->Link_ID);
	}

	# Optimize a table
	# $tbl_name : the name of the table
	function optimize($tbl_name)
	{
		$this->connect();
		$this->Query_ID = @mysql_query("OPTIMIZE TABLE $tbl_name",$this->Link_ID);
	}

	# Free the memory used by a result
	function clean_results()
	{
		if($this->Query_ID != 0)
		{
			mysql_freeresult($this->Query_ID);
		}
	}

	# Close the link to the MySQL database	
	function close()
	{
		if($this->Link_ID != 0)
		{
			mysql_close($this->Link_ID);
		}
	}
}
?>